SystemOrganization addCategory: #'SWE-IssueTracker'!

SUComponent subclass: #ITComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITComponent methodsFor: 'updating' stamp: 'mt 12/30/2007 10:29'!
updateRoot: anHtmlRoot
	"Appends a unique style to all used components."
	
	super updateRoot: anHtmlRoot.
	anHtmlRoot stylesheet
		url: ITFileLibrary / #mainCss.! !

ITComponent subclass: #ITComponentAddComment
	instanceVariableNames: 'comment issueID'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITComponentAddComment class methodsFor: 'instance creation' stamp: 'mig 11/30/2007 19:36'!
newWith: anID
	| newInstance |
	newInstance := self new.
	newInstance issueID: anID.
	^newInstance.! !

!ITComponentAddComment methodsFor: 'accessing' stamp: 'mig 11/30/2007 19:11'!
comment
	^ comment! !

!ITComponentAddComment methodsFor: 'accessing' stamp: 'mig 11/30/2007 19:11'!
comment: anObject
	comment := anObject! !

!ITComponentAddComment methodsFor: 'accessing' stamp: 'mig 11/30/2007 19:36'!
issueID
	^ issueID! !

!ITComponentAddComment methodsFor: 'accessing' stamp: 'mig 11/30/2007 19:36'!
issueID: anObject
	issueID := anObject! !

!ITComponentAddComment methodsFor: 'rendering' stamp: 'mig 12/19/2007 13:46'!
renderBox: aString on: html

	html div id: aString; class: 'box'; style: 'display: none; '; with: [
		html div class: 'header'.
		html div
			class: 'content';
			with: [	html form: [
						html textArea on: #comment of: self.
						html break.
						html submitButton
							callback: [
								| issue issueManager |
								issueManager := self session issueManager.
								issue := issueManager getIssueWithID: self issueID.
				
								issueManager addComment: self comment atID: self issueID.
							];
							text: 'Add Comment'.
						]] 
				]! !

!ITComponentAddComment methodsFor: 'rendering' stamp: 'mig 12/19/2007 13:42'!
renderContentOn: html

	html paragraph: [
			html anchor
				onClick: (html effect id: 'toggle'; perform: #toggleSlide);
			with: 'Add Comment'].""
	self renderBox: 'toggle' on: html. 
! !

ITComponent subclass: #ITComponentAddIssue
	instanceVariableNames: 'title initialComment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITComponentAddIssue methodsFor: 'accessing' stamp: 'afk 11/12/2007 15:49'!
initialComment
	^ initialComment! !

!ITComponentAddIssue methodsFor: 'accessing' stamp: 'afk 11/12/2007 15:49'!
initialComment: anObject
	initialComment := anObject! !

!ITComponentAddIssue methodsFor: 'rendering' stamp: 'mig 12/10/2007 17:48'!
renderContentOn: html
	html heading 
		level: 1;
		with: 'Add Issue'.
	html form: 
		[
		html text: 'Title'.
			html break.
		html textInput on: #title of: self.
			html break.
		html text: 'Description'.
			html break.
		html textArea on: #initialComment of: self.
			html break.
		html submitButton 
			callback: [
				self session issueManager addIssueWithTitle: self title withComment: self initialComment.
				self answer. 
			];
			value: 'add Issue'.
		html cancelButton
			callback: [self answer];
			value: 'cancel'.
		]! !

!ITComponentAddIssue methodsFor: 'accessing' stamp: 'afk 11/12/2007 15:49'!
title
	^ title! !

!ITComponentAddIssue methodsFor: 'accessing' stamp: 'afk 11/12/2007 15:49'!
title: anObject
	title := anObject! !

ITComponent subclass: #ITComponentDetails
	instanceVariableNames: 'issueID addcomment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITComponentDetails class methodsFor: 'instance creation' stamp: 'mig 11/30/2007 19:36'!
newWith: anID
	|view|
	view := self new.
	view issueID: anID.
	^view.! !

!ITComponentDetails methodsFor: 'accessing' stamp: 'mig 11/30/2007 19:16'!
children
	^ Array with: addcomment.! !

!ITComponentDetails methodsFor: 'accessing' stamp: 'mig 11/30/2007 19:34'!
issueID
	^ issueID! !

!ITComponentDetails methodsFor: 'accessing' stamp: 'mig 11/30/2007 19:34'!
issueID: anObject
	issueID := anObject! !

!ITComponentDetails methodsFor: 'rendering' stamp: 'mig 12/10/2007 17:49'!
renderContentOn: html

	| issue |
	
	issue := self session issueManager getIssueWithID: self issueID.
	addcomment := ITComponentAddComment newWith: self issueID.

	html heading
		level: 2;
		with: 'detailed view of an issue'.
	html div
		with: [
			html text: issue id.
			html break.
			html text: (issue getTag: 'title').
			
			html break; break.
			html table: [
				(issue comments) do: [:comment|
					html tableRow: [ html tableData: [ html text: comment content ] ].

				].
				html tableRow: [ 
					html tableData with: addcomment.
				].
			].
			html anchor
				callback: [self answer];
				with: [html text: 'return to list'].
		]
					
				! !

ITComponent subclass: #ITComponentListIssues
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITComponentListIssues methodsFor: 'rendering' stamp: 'afk 12/13/2007 21:54'!
renderContentOn: html
	| issues |
	issues := self session issueManager getIssues.
	html heading 
		level: 2;
		with: 'List all issues'.
	html form:[
		html table:[
			html tableRow: [
				html tableData: 'id'.
				html tableData: 'title'.
				html tableData: 'details'.
				html tableData: 'delete'.
				].
			issues do: [:issue|
				html tableRow: [
					html tableData: (issue id asString).
					html tableData: (issue getTag: 'title').
					html tableData: [
						html anchor 
							callback: [self call: (ITComponentDetails newWith: issue id)];
							with: [html text: 'detailed view'].
						].
					html tableData: [
						html anchor
							callback: [((self session issueManager) deleteIssueWithID: issue id)];
							with: [html text: 'delete'].
						].
					].
				].
			].
		].! !

ITComponent subclass: #ITComponentLogin
	instanceVariableNames: 'userInput passwordInput'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITComponentLogin methodsFor: 'accessing' stamp: 'mig 12/17/2007 13:42'!
passwordInput
	^ passwordInput! !

!ITComponentLogin methodsFor: 'accessing' stamp: 'mig 12/17/2007 13:42'!
passwordInput: anObject
	passwordInput := anObject! !

!ITComponentLogin methodsFor: 'rendering' stamp: 'mig 12/17/2007 13:58'!
renderContentOn: html
	html form: [
		html text: 'username:'.
		html textInput on: #userInput of: self.
		html break.
		html text: 'password:'.
		html passwordInput on: #passwordInput of: self.
		html break.
		html submitButton callback: [
			| valid |
			valid := self session securityManager validatePassword: self passwordInput for: self userInput.
			valid ifTrue: [
				self session user: (self session securityManager getUser: userInput).
				self answer: true.
			] ifFalse: [
				self inform: 'Wrong username/password combination!!'.
			].
		]; value: 'Login'.
		html cancelButton callback: [
			self answer: false.
		]; value: 'Cancel'.
	].! !

!ITComponentLogin methodsFor: 'accessing' stamp: 'mig 12/17/2007 13:42'!
userInput
	^ userInput! !

!ITComponentLogin methodsFor: 'accessing' stamp: 'mig 12/17/2007 13:42'!
userInput: anObject
	userInput := anObject! !

ITComponent subclass: #ITComponentMenu
	instanceVariableNames: 'listIssues userStatus'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITComponentMenu class methodsFor: 'testing' stamp: 'mt 11/23/2007 18:52'!
canBeRoot
	^true.! !

!ITComponentMenu methodsFor: 'initialize' stamp: 'mig 12/17/2007 14:35'!
children
	^Array with: self listIssues with: self userStatus.! !

!ITComponentMenu methodsFor: 'initialize' stamp: 'mig 12/17/2007 14:35'!
initialize
	super initialize.
	self listIssues: ITComponentListIssues new.
	self userStatus: ITComponentUserStatus new.! !

!ITComponentMenu methodsFor: 'accessing' stamp: 'mt 11/23/2007 19:05'!
listIssues
	^ listIssues! !

!ITComponentMenu methodsFor: 'accessing' stamp: 'mt 11/23/2007 19:05'!
listIssues: anObject
	listIssues := anObject! !

!ITComponentMenu methodsFor: 'rendering' stamp: 'mt 12/29/2007 16:45'!
renderContentOn: html

	html heading
		level: 1;
		with: 'IssueTracker'.
		
	" Clock "
	html paragraph
		script: (html updater
			every: 1 second;
			on: #renderTimeOn: of: self);
		with: [ self renderTimeOn: html ].
		
	html span with: self userStatus.
	html text: ' '.
	html anchor 
		callback: [ self call: ITComponentAddIssue new ]; 
		with: [ html text: 'add issue' tr].
	html text: ' | '.
	html anchor 
		callback: [ self call: ITComponentSMMenu new ]; 
		with: [ html text: 'security management' tr].
	html div
		with: self listIssues.! !

!ITComponentMenu methodsFor: 'rendering' stamp: 'mig 12/19/2007 13:51'!
renderTimeOn: html
	html render: Time now print24! !

!ITComponentMenu methodsFor: 'accessing' stamp: 'mig 12/17/2007 14:36'!
userStatus
	^ userStatus! !

!ITComponentMenu methodsFor: 'accessing' stamp: 'mig 12/17/2007 14:36'!
userStatus: anObject
	userStatus := anObject! !

ITComponent subclass: #ITComponentSMMenu
	instanceVariableNames: 'active privMgm roleMgm'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITComponentSMMenu methodsFor: 'accessing' stamp: 'mt 12/29/2007 15:30'!
active
	^ active! !

!ITComponentSMMenu methodsFor: 'accessing' stamp: 'mt 12/29/2007 15:30'!
active: anObject
	active := anObject! !

!ITComponentSMMenu methodsFor: 'rendering' stamp: 'mt 12/29/2007 15:15'!
children
	^Array with: privMgm with: roleMgm.! !

!ITComponentSMMenu methodsFor: 'initialization' stamp: 'mt 12/29/2007 15:55'!
initialize
	super initialize.
	
	self privMgm: ITComponentSMPrivilegeManagement new.
	self roleMgm: ITComponentSMRoleManagement new.
	active := nil.! !

!ITComponentSMMenu methodsFor: 'accessing' stamp: 'mt 12/29/2007 15:47'!
privMgm
	^ privMgm! !

!ITComponentSMMenu methodsFor: 'accessing' stamp: 'mt 12/29/2007 15:47'!
privMgm: anObject
	privMgm := anObject! !

!ITComponentSMMenu methodsFor: 'rendering' stamp: 'mt 12/29/2007 15:48'!
renderButtonOn: html with: text action: anUpdate
	html anchor
		class: 'button';
		onClick: anUpdate;
		with: [ html span
			class: 'button';
			with: [html text: text ]
		].
	^'a button'! !

!ITComponentSMMenu methodsFor: 'rendering' stamp: 'mt 12/29/2007 16:41'!
renderContentOn: html
	
	html heading: 'Security Management' level: 1.
	html div
		class: 'security_menu';
		with: [
			self renderButtonOn: html with: 'User Management' tr action: 
				(html updater id: 'security_widget'; callback: [:r | r render: 'TODO']).
			self renderButtonOn: html with: 'Role Management' tr action: 
				(html updater id: 'security_widget'; callback: [:r | self active: self roleMgm. r render: self active]).
			self renderButtonOn: html with: 'Privlege Management' tr action:
				(html updater id: 'security_widget'; callback: [:r | self active: self privMgm. r render: self active]).
		].
	
	html div
		id: 'security_widget';
		class: 'security_container';
		with: [
			active isNil ifFalse: [ html render: self active]
		]
! !

!ITComponentSMMenu methodsFor: 'accessing' stamp: 'mt 12/29/2007 15:47'!
roleMgm
	^ roleMgm! !

!ITComponentSMMenu methodsFor: 'accessing' stamp: 'mt 12/29/2007 15:47'!
roleMgm: anObject
	roleMgm := anObject! !

ITComponent subclass: #ITComponentSMPrivilegeManagement
	instanceVariableNames: 'attachedPrivileges availablePrivileges selectedRole'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITComponentSMPrivilegeManagement methodsFor: 'as yet unclassified' stamp: 'mt 12/29/2007 16:07'!
applyChanges
	|session|
	session := ITGlorpSession getInstance.
	session inUnitOfWorkDo: [
		session register: selectedRole.
		selectedRole privileges: self attachedPrivileges asSet.
		]! !

!ITComponentSMPrivilegeManagement methodsFor: 'accessing' stamp: 'mt 12/29/2007 15:12'!
attachedPrivileges
	^ attachedPrivileges! !

!ITComponentSMPrivilegeManagement methodsFor: 'accessing' stamp: 'mt 12/29/2007 15:12'!
attachedPrivileges: anObject
	attachedPrivileges := anObject! !

!ITComponentSMPrivilegeManagement methodsFor: 'accessing' stamp: 'mt 12/29/2007 15:12'!
availablePrivileges
	^ availablePrivileges! !

!ITComponentSMPrivilegeManagement methodsFor: 'accessing' stamp: 'mt 12/29/2007 15:12'!
availablePrivileges: anObject
	availablePrivileges := anObject! !

!ITComponentSMPrivilegeManagement methodsFor: 'initialization' stamp: 'mt 12/29/2007 16:15'!
initialize
	super initialize.
	
	selectedRole := ITGlorpSession getInstance readOneOf: ITRole.
	self updatePrivileges.! !

!ITComponentSMPrivilegeManagement methodsFor: 'rendering' stamp: 'mt 12/29/2007 16:05'!
renderContentOn: html
	html heading: 'Privilege Management' tr level: 2.
	
	html form
		id: 'role_drop_down';
		with: [
			html select
				list: (ITGlorpSession getInstance read: ITRole);
				selected: selectedRole;
				labels: [:role|role rolename];
				callback: [ :value | selectedRole := value ];
				onChange: (html updater
					id: 'privilege_lists';
					triggerForm: 'role_drop_down';
					callback: [:r | self updatePrivileges; renderPrivilegeListsOn: r]).
		].
	
	html div
		id: 'privilege_lists';
		with: [ self renderPrivilegeListsOn: html ].
	
	html div
		with: [
			html anchor
				callback: [self applyChanges];
				with: 'Apply changes to role' tr
		].! !

!ITComponentSMPrivilegeManagement methodsFor: 'rendering' stamp: 'mt 12/29/2007 16:13'!
renderListItems: aSelector on: html
	html unorderedList
		id: aSelector asString;
		style: 'width: 200px; min-height: 50px;';
		script: (html sortable
			constraint: false;
			dropOnEmpty: true;
			containment: #( availablePrivileges attachedPrivileges );
			onUpdate: (html updater
				id: 'actual_privileges';
				triggerSortable: aSelector	callback: [ :values | self perform: aSelector asMutator with: values ]
				"callback: [ :renderer | self renderActualPrivilegesOn: renderer ]"
			)
		);
		with: [
			(self perform: aSelector) do: [ :each |
				html listItem
					passenger: each;
					class: 'green';
					with: each ] ]! !

!ITComponentSMPrivilegeManagement methodsFor: 'rendering' stamp: 'mt 12/29/2007 16:16'!
renderPrivilegeListsOn: html

			html text: 'Current Role: ', selectedRole rolename.

"	html div
		id: 'actual_privileges';
		with: [ self renderActualPrivilegesOn: html ]."

			html div
				style: 'float: left;';
				with: [ html heading: 'available privileges' tr level: 3. self renderListItems: #availablePrivileges on: html ].
			html div
				style: 'float: left;';
				with: [ html heading: 'attached privileges' tr level: 3. self renderListItems: #attachedPrivileges on: html ].
			html div
				style: 'clear: both'.! !

!ITComponentSMPrivilegeManagement methodsFor: 'as yet unclassified' stamp: 'mt 12/29/2007 16:38'!
updatePrivileges
	"Updates the available and attached privileges to the current selected role."
	
	self flag: #TODO. "Where do all privileges come from?"
	
	self attachedPrivileges: selectedRole privileges.
	self availablePrivileges:	(
		#(listissues readissue writeissue deleteissue) asSet collect: [:each |
			(selectedRole privileges includes: each) not ifTrue: [each]
		]
	).! !

ITComponent subclass: #ITComponentSMRoleManagement
	instanceVariableNames: 'attachedRoles availableRoles selectedUser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITComponentSMRoleManagement methodsFor: 'as yet unclassified' stamp: 'mt 12/29/2007 12:24'!
applyChanges
	|session|
	session := ITGlorpSession getInstance.
	session inUnitOfWorkDo: [
		session register: selectedUser.
		selectedUser roles: self attachedRoles asSet.
		]! !

!ITComponentSMRoleManagement methodsFor: 'accessing' stamp: 'mt 12/29/2007 10:07'!
attachedRoles
	^ attachedRoles! !

!ITComponentSMRoleManagement methodsFor: 'accessing' stamp: 'mt 12/29/2007 10:07'!
attachedRoles: anObject
	attachedRoles := anObject! !

!ITComponentSMRoleManagement methodsFor: 'accessing' stamp: 'mt 12/29/2007 10:07'!
availableRoles
	^ availableRoles! !

!ITComponentSMRoleManagement methodsFor: 'accessing' stamp: 'mt 12/29/2007 10:07'!
availableRoles: anObject
	availableRoles := anObject! !

!ITComponentSMRoleManagement methodsFor: 'as yet unclassified' stamp: 'mt 12/29/2007 12:07'!
initialize
	super initialize.
	
	selectedUser := ITGlorpSession getInstance readOneOf: ITUser.
	self updateRoles.! !

!ITComponentSMRoleManagement methodsFor: 'rendering' stamp: 'mt 12/29/2007 14:08'!
renderActualPrivilegesOn: html
	"Shows the current privileges the selected user would have if you apply/save the changes."
	
	| priv |
	priv := Set new.
	html text: 'actual Privileges: ' tr.
	self attachedRoles do: [:role | priv := priv union: role privileges ].
	
	priv do: [:privilege | html text: privilege, ' '].! !

!ITComponentSMRoleManagement methodsFor: 'rendering' stamp: 'mt 12/29/2007 16:01'!
renderContentOn: html
	html heading: 'Role Management' tr level: 2.
	
	html form
		id: 'user_drop_down';
		with: [
			html select
				list: (ITGlorpSession getInstance read: ITUser);
				selected: selectedUser;
				labels: [:user|user username];
				callback: [ :value | selectedUser := value ];
				onChange: (html updater
					id: 'role_lists'; "in which the callback will be processed"
					triggerForm: 'user_drop_down';
					callback: [:r | self updateRoles; renderRoleListsOn: r]).
			"	onChange: (html updater
					id: 'actual_privileges';
					callback: [:r | self renderActualPrivilegesOn: r])."
		].
	
	html div
		id: 'role_lists';
		with: [ self renderRoleListsOn: html ].
	
	html div
		with: [
			html anchor
				callback: [self applyChanges];
				with: 'Apply changes to user' tr
		].! !

!ITComponentSMRoleManagement methodsFor: 'rendering' stamp: 'mt 12/29/2007 13:50'!
renderListItems: aSelector on: html
	html unorderedList
		id: aSelector asString;
		style: 'width: 200px; min-height: 50px;';
		script: (html sortable
			constraint: false;
			dropOnEmpty: true;
			containment: #( availableRoles attachedRoles );
			onUpdate: (html updater
				id: 'actual_privileges';
				triggerSortable: aSelector	callback: [ :values | self perform: aSelector asMutator with: values ];
				callback: [ :renderer | self renderActualPrivilegesOn: renderer ]
			)
		);
		with: [
			(self perform: aSelector) do: [ :each |
				html listItem
					passenger: each;
					class: 'orange';
					with: each rolename ] ]! !

!ITComponentSMRoleManagement methodsFor: 'rendering' stamp: 'mt 12/29/2007 16:03'!
renderRoleListsOn: html

			html text: 'Current User: ', selectedUser username.

	html div
		id: 'actual_privileges';
		with: [ self renderActualPrivilegesOn: html ].

			html div
				style: 'float: left;';
				with: [ html heading: 'available roles' tr level: 3. self renderListItems: #availableRoles on: html ].
			html div
				style: 'float: left;';
				with: [ html heading: 'attached roles' tr level: 3. self renderListItems: #attachedRoles on: html ].
			html div
				style: 'clear: both'.! !

!ITComponentSMRoleManagement methodsFor: 'as yet unclassified' stamp: 'mt 12/29/2007 12:44'!
updateRoles
	"Updates the available and attached roles to the current selected User."
	
	self attachedRoles: selectedUser roles.
	self availableRoles:	(
		(ITGlorpSession getInstance read: ITRole) asSet collect: [:each |
			(selectedUser roles includes: each) not ifTrue: [each]
		]
	).! !

ITComponent subclass: #ITComponentUserRegister
	instanceVariableNames: 'userInput passwordInput1 passwordInput2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITComponentUserRegister methodsFor: 'accessing' stamp: 'mig 12/17/2007 14:00'!
passwordInput1
	^ passwordInput1! !

!ITComponentUserRegister methodsFor: 'accessing' stamp: 'mig 12/17/2007 14:00'!
passwordInput1: anObject
	passwordInput1 := anObject! !

!ITComponentUserRegister methodsFor: 'accessing' stamp: 'mig 12/17/2007 14:00'!
passwordInput2
	^ passwordInput2! !

!ITComponentUserRegister methodsFor: 'accessing' stamp: 'mig 12/17/2007 14:00'!
passwordInput2: anObject
	passwordInput2 := anObject! !

!ITComponentUserRegister methodsFor: 'rendering' stamp: 'mig 12/20/2007 18:37'!
renderContentOn: html
	html div style: 'background: white; padding: 20px;'; with: [
		html form: [
			html text: 'username:'.
			html textInput on: #userInput of: self.
			html break.
			html text: 'password:'.
			html passwordInput on: #passwordInput1 of: self.
			html break.
			html text: 'verify:'.
			html passwordInput on: #passwordInput2 of: self.
			html break.
			html submitButton callback: [
				| user |
				(self session securityManager getUser: self userInput) ifNotNil: [
					self inform: 'Username already exists!!'.
				] ifNil: [
					self passwordInput1 = self passwordInput2 ifFalse: [
						self inform: 'Passwords do not match!!'.
					] ifTrue:	[
						user := ITUser new.
						user 
							username: self userInput;
							setPassword: self passwordInput1.
						self session securityManager addUser: user.
						self answer.]
				].
			]; value: 'Register'.
			html cancelButton callback: [
			self answer.
			]; value: 'Cancel'.
		].
	].! !

!ITComponentUserRegister methodsFor: 'accessing' stamp: 'mig 12/17/2007 14:00'!
userInput
	^ userInput! !

!ITComponentUserRegister methodsFor: 'accessing' stamp: 'mig 12/17/2007 14:00'!
userInput: anObject
	userInput := anObject! !

ITComponent subclass: #ITComponentUserStatus
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITComponentUserStatus methodsFor: 'rendering' stamp: 'mig 12/19/2007 13:49'!
renderContentOn: html
	self session user ifNil: [
		html text: '[ '.
		html anchor
			callback: [ self lightbox: ITComponentLogin new ]; 
			with: [ html text: 'login'].
		html text: ' | '.
		html anchor 
			callback: [ self lightbox: ITComponentUserRegister new ]; 
			with: [ html text: 'register'].
		html text: ' ]'.
	] ifNotNil: [
		html text: '[ Logged in as ', self session user username, ' | '.
		html anchor
			callback: [self session user: nil.];
			with: 'logout'.
		html text: ' ]'.
	].! !

GlorpSession subclass: #ITGlorpSession
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

ITGlorpSession class
	instanceVariableNames: 'instance'!

!ITGlorpSession commentStamp: 'mt 12/15/2007 10:12' prior: 0!
I'm a usual GlorpSession and control a cache manager, a description system and all unit of works. Every manipulation of the SQL database goes through my "fingers".

Use #inUnitOfWorkDo: for watching over "dirty" objects and change all relevant data in the database. But DO NOT forget to register them with #register inside a unit of work.

Any read of data doesn't have to be embedded in a unit of work. Just use the result of #read:, #readOneOf:, #readManyOf:, #read:where: a. s. o.

If you want to delete an object you doesn't have to use a unit of work either.!

ITGlorpSession class
	instanceVariableNames: 'instance'!

!ITGlorpSession class methodsFor: 'accessing' stamp: 'afk 12/15/2007 13:10'!
getInstance
	"Using singleton pattern to ensure that there is only one instance of ITGlorpSession"
	
	instance ifNil:
		[ instance := ITGlorpDB connect.].
	instance isLoggedIn ifFalse:
		[ instance := ITGlorpDB connect.].
	^ instance! !

!ITGlorpSession class methodsFor: 'instance creation' stamp: 'mt 12/26/2007 10:52'!
new
	Error signal: 'Use getInstance because', self name, ' is a singleton.'! !

DescriptorSystem subclass: #ITGlorpDescriptorSystem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITGlorpDescriptorSystem commentStamp: 'mt 12/30/2007 10:33' prior: 0!
I'm the descriptor system that should be used in every new ITGlorpSession. I'm responsible for all mappings between the IT-Classes and the relevant tables on the SQL server.

You should modify #allTableNames and #constructAllClasses whenever you want to add new objects of the domain space for usage here.

#tableNamed<TABLE_NAME>    ... descriptions about the table structure on the server
#descriptorFor<CLASS_NAME> ... defines mappings between classes and tables
#classModelFor<CLASS_NAME> ... defines types (classes) for symbols (attributes) used by mappings

The relational schemes can be found in the comments for any #tableNamed<TABLE_NAME>. Primary keys are underlined, e.g. SCHEME(ATTRIBUTE_A, ATTRIBUTE_B)
                    -----------!

!ITGlorpDescriptorSystem methodsFor: 'accessing' stamp: 'mig 12/16/2007 19:19'!
allTableNames
	"Here are all tables listed which hold all persistent data."
	
	^ #('ISSUE' 'COMMENT' 'DETAIL' 'USERS' 'ROLE' 'USERROLE' 'ROLEPRIVILEGE')! !

!ITGlorpDescriptorSystem methodsFor: 'class models' stamp: 'mt 12/14/2007 09:54'!
classModelForITIssue: aClassModel
	"The unique ID can be up to 1.073.741.823 - should be enough.
	 -> SmallInteger maxVal
	 4-Byte-Integers (signed) are used in the database"
	
	aClassModel newAttributeNamed: #id type: SmallInteger.
	aClassModel newAttributeNamed: #comments collection: OrderedCollection  of: ITIssueComment.
	aClassModel newAttributeNamed: #details collection: OrderedCollection  of: ITIssueDetail.! !

!ITGlorpDescriptorSystem methodsFor: 'class models' stamp: 'mt 12/14/2007 09:55'!
classModelForITIssueComment: aClassModel
	"See #classModelForITIssue for explanation of ID."
	
	aClassModel newAttributeNamed: #id type: SmallInteger.
	aClassModel newAttributeNamed: #content type: String.! !

!ITGlorpDescriptorSystem methodsFor: 'class models' stamp: 'mt 12/14/2007 09:55'!
classModelForITIssueDetail: aClassModel
	"See #classModelForITIssue for explanation of ID."

	aClassModel newAttributeNamed: #id type: SmallInteger.
	aClassModel newAttributeNamed: #tag type: String.
	aClassModel newAttributeNamed: #content type: String.! !

!ITGlorpDescriptorSystem methodsFor: 'class models' stamp: 'mig 12/17/2007 13:29'!
classModelForITRole: aClassModel

	aClassModel newAttributeNamed: #id type: SmallInteger.
	aClassModel newAttributeNamed: #rolename type: String.
	aClassModel newAttributeNamed: #privileges collection: Set of: String.
	! !

!ITGlorpDescriptorSystem methodsFor: 'class models' stamp: 'mig 12/17/2007 14:57'!
classModelForITUser: aClassModel

	aClassModel newAttributeNamed: #id type: SmallInteger.
	aClassModel newAttributeNamed: #username type: String.
	aClassModel newAttributeNamed: #passwordHash type: String.
	aClassModel newAttributeNamed: #roles collection: Set of: ITRole.
! !

!ITGlorpDescriptorSystem methodsFor: 'accessing' stamp: 'mig 12/16/2007 19:41'!
constructAllClasses
	"Here are all classes listed which are necessary for the mappings."
	
	^ (super constructAllClasses)
		add: ITIssue;
		add: ITIssueComment;
		add: ITIssueDetail;
		add: ITUser;
		add: ITRole;
		yourself! !

!ITGlorpDescriptorSystem methodsFor: 'descriptors' stamp: 'mt 12/14/2007 09:45'!
descriptorForITIssue: aDescriptor
	"Every issue contains a unique ID, a collection of comments and a collection of details."
	
	| issueTable commentTable detailTable |
	issueTable   := self tableNamed: 'ISSUE'.
	commentTable := self tableNamed: 'COMMENT'.
	detailTable  := self tableNamed: 'DETAIL'.

	aDescriptor table: issueTable.
	
	(aDescriptor newMapping: DirectMapping) from: #id to: (issueTable fieldNamed: 'ID').

	(aDescriptor newMapping: ToManyMapping)
		attributeName: #comments;
		join: (Join
			from: (issueTable fieldNamed: 'ID')
			to: (commentTable	fieldNamed: 'ISSUE_ID')
		).
	
	(aDescriptor newMapping: ToManyMapping)
		attributeName: #details;
		join: (Join
			from: (issueTable fieldNamed: 'ID')
			to:  (detailTable fieldNamed: 'ISSUE_ID')
		).! !

!ITGlorpDescriptorSystem methodsFor: 'descriptors' stamp: 'mt 12/14/2007 09:47'!
descriptorForITIssueComment: aDescriptor
	"Every comment contains a unique ID and its content - should be text."
	
	| table |
	table := self tableNamed: 'COMMENT'.
	aDescriptor table: table.
	
	(aDescriptor newMapping: DirectMapping) from: #id to: (table fieldNamed: 'ID').
	(aDescriptor newMapping: DirectMapping) from: #content to: (table fieldNamed: 'CONTENT').! !

!ITGlorpDescriptorSystem methodsFor: 'descriptors' stamp: 'mt 12/14/2007 09:47'!
descriptorForITIssueDetail: aDescriptor
	"Every detail contains a unique ID, a tag and its content."

	| table |
	table := self tableNamed: 'DETAIL'.
	aDescriptor table: table.
	
	(aDescriptor newMapping: DirectMapping) from: #id to: (table fieldNamed: 'ID').
	(aDescriptor newMapping: DirectMapping) from: #tag to: (table fieldNamed: 'TAG').
	(aDescriptor newMapping: DirectMapping) from: #content to: (table fieldNamed: 'CONTENT').! !

!ITGlorpDescriptorSystem methodsFor: 'descriptors' stamp: 'mig 12/16/2007 19:26'!
descriptorForITRole: aDescriptor
	
	| roleTable userRoleTable rolePrivilegeTable |
	roleTable := self tableNamed: 'ROLE'.
	userRoleTable := self tableNamed: 'USERROLE'.
	rolePrivilegeTable := self tableNamed: 'ROLEPRIVILEGE'.

	aDescriptor table: roleTable.
	
	(aDescriptor newMapping: DirectMapping) from: #id to: (roleTable fieldNamed: 'ID').
	(aDescriptor newMapping: DirectMapping) from: #rolename to: (roleTable fieldNamed: 'ROLENAME').

	(aDescriptor newMapping: ManyToManyMapping)
		attributeName: #users;
		referenceClass: ITUser;
		mappingCriteria: (Join
			from: (roleTable fieldNamed: 'ID')
			to:  (userRoleTable fieldNamed: 'ROLE_ID')
		).
	
	(aDescriptor newMapping: DirectToManyMapping)
		attributeName: #privileges;
		resultField: (rolePrivilegeTable fieldNamed: 'PRIVILEGE');
		writeTheOrderField;
		orderBy: [:each | (each getTable: rolePrivilegeTable) getField: 'PRIVILEGE_ORDER'];
		join: (Join from: (roleTable fieldNamed: 'ID') to: (rolePrivilegeTable fieldNamed: 'ROLE_ID')).! !

!ITGlorpDescriptorSystem methodsFor: 'descriptors' stamp: 'mig 12/16/2007 19:41'!
descriptorForITUser: aDescriptor
	
	| userTable userRoleTable |
	userTable   := self tableNamed: 'USERS'.
	userRoleTable := self tableNamed: 'USERROLE'.

	aDescriptor table: userTable.
	
	(aDescriptor newMapping: DirectMapping) from: #id to: (userTable fieldNamed: 'ID').
	(aDescriptor newMapping: DirectMapping) from: #username to: (userTable fieldNamed: 'USERNAME').
	(aDescriptor newMapping: DirectMapping) from: #passwordHash to: (userTable fieldNamed: 'PASSWORDHASH').

	(aDescriptor newMapping: ManyToManyMapping)
		attributeName: #roles;
		referenceClass: ITRole;
		mappingCriteria: (Join
			from: (userTable fieldNamed: 'ID')
			to:  (userRoleTable fieldNamed: 'USER_ID')
		).! !

!ITGlorpDescriptorSystem methodsFor: 'tables' stamp: 'mt 12/15/2007 14:29'!
tableForCOMMENT: aTable
	"COMMENTS(ID, ISSUE_ID, TIMESTAMP, CONTENT)
	          --"
	
	| issueId |
	(aTable createFieldNamed: 'ID' type: (platform sequence)) bePrimaryKey.
	issueId := aTable createFieldNamed: 'ISSUE_ID' type: (platform int4).
	aTable createFieldNamed: 'TIMESTAMP' type: (platform timestamp).
	aTable createFieldNamed: 'CONTENT' type: (platform text).
	
	"foreign key definition for the IDs of issues"
	aTable 
		addForeignKeyFrom: issueId 
		to: ((self tableNamed: 'ISSUE') fieldNamed: 'ID')
		suffixExpression: 'ON DELETE CASCADE'.
		! !

!ITGlorpDescriptorSystem methodsFor: 'tables' stamp: 'mt 12/15/2007 14:28'!
tableForDETAIL: aTable
	"DETAIL(ID, ISSUE_ID, TAG, CONTENT)
	       --"
	
	| issueID |
	(aTable createFieldNamed: 'ID' type: (platform sequence)) bePrimaryKey.
	issueID := (aTable createFieldNamed: 'ISSUE_ID' type: (platform int4)).
	aTable createFieldNamed: 'TAG' type: (platform varchar: 255).
	aTable createFieldNamed: 'CONTENT' type: (platform varchar: 255).
	
	"foreign key definition for IDs of issues"
	aTable
		addForeignKeyFrom: issueID
		to: ((self tableNamed: 'ISSUE') fieldNamed: 'ID')
		suffixExpression: 'ON DELETE CASCADE'.! !

!ITGlorpDescriptorSystem methodsFor: 'tables' stamp: 'mt 12/14/2007 09:38'!
tableForISSUE: aTable
	"ISSUE(ID)
	       --"
	
	(aTable createFieldNamed: 'ID' type: (platform sequence)) bePrimaryKey.! !

!ITGlorpDescriptorSystem methodsFor: 'tables' stamp: 'mig 12/17/2007 00:50'!
tableForROLE: aTable
	"ROLE(ID, ROLENAME)"
	
	(aTable createFieldNamed: 'ID' type: platform sequence) bePrimaryKey.
	aTable createFieldNamed: 'ROLENAME' type: (platform varchar: 255).! !

!ITGlorpDescriptorSystem methodsFor: 'tables' stamp: 'mig 12/17/2007 14:51'!
tableForROLEPRIVILEGE: aTable
	"ROLEPRIVILEGE(ROLE_ID, PRIVILEGE, PRIVILEGE_ORDER)"
	
	| roleid privilege |
	
	roleid := aTable createFieldNamed: 'ROLE_ID' type: platform int4.
	privilege := aTable createFieldNamed: 'PRIVILEGE' type: platform text.
	aTable createFieldNamed: 'PRIVILEGE_ORDER' type: platform int4.
	
	roleid bePrimaryKey.
	privilege bePrimaryKey.
	
	aTable 
		addForeignKeyFrom: roleid 
		to: ((self tableNamed: 'ROLE') fieldNamed: 'ID')
		suffixExpression: 'ON DELETE CASCADE'.
! !

!ITGlorpDescriptorSystem methodsFor: 'tables' stamp: 'mig 12/17/2007 01:01'!
tableForUSERROLE: aTable
	"USERROLE(USER_ID, ROLE_ID)"

	| userid roleid |
	
	userid := aTable createFieldNamed: 'USER_ID' type: (platform int4).
	roleid := aTable createFieldNamed: 'ROLE_ID' type: (platform int4).
		
	aTable 
		addForeignKeyFrom: userid 
		to: ((self tableNamed: 'USERS') fieldNamed: 'ID')
		suffixExpression: 'ON DELETE CASCADE'.
		
	aTable 
		addForeignKeyFrom: roleid 
		to: ((self tableNamed: 'ROLE') fieldNamed: 'ID')
		suffixExpression: 'ON DELETE CASCADE'.
! !

!ITGlorpDescriptorSystem methodsFor: 'tables' stamp: 'mig 12/17/2007 01:02'!
tableForUSERS: aTable
	"USERS(ID, USERNAME, PASSWORDHASH)"
	
	(aTable createFieldNamed: 'ID' type: platform sequence) bePrimaryKey.
	aTable createFieldNamed: 'USERNAME' type: (platform varchar: 255).
	aTable createFieldNamed: 'PASSWORDHASH' type: (platform varchar: 255).! !

WAFileLibrary subclass: #ITFileLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITFileLibrary commentStamp: 'mt 12/30/2007 10:32' prior: 0!
This is the place for all (former) external resources. Style sheets, images, other files. You have access to these files with: "ITFileLibrary / #filenameExtension" which creates you a WAUrl instance for proper usage.

You should modify these files through the web frontend of seaside.!

!ITFileLibrary methodsFor: 'uploaded' stamp: ''!
mainCss
	^ 'h1 {
		font-size: 20px;
		font-family: Verdana,Arial;		
	}
	
	h2 {
		font-size: 15px;
		font-family: Verdana,Arial;	
	}
	
	h3 {
		font-size: 10px;
		font-family: Verdana,Arial;		
	}
	/* a simple button */
	a.button, a.button:hover {
		text-decoration: none;		
		color: #000
	}
	
	a.button:hover {
		color: #00f;
	}
	
	div span.button, div span.button:hover {
		margin: 5px;
		padding: 5px;
		font-size: 10px;
		font-family: Verdana,Arial;
		border-width: 1px;
		border-style: dotted;
		border-color: #000;
		width: 100px;
	/*	text-align: center; */
		background-color: #fff;		
	}
	
	div span.button:hover {
		border-style: solid;
		background-color: #ff0;
	}
	
	div.security_container {
		padding: 10px;
		border-width: 1px;
		border-style: solid;
		width: 500px;
	}
	
	div.security_menu {
		margin: 0px;
	}

li.green, li.orange {
	margin: 4px;
	padding: 2px;
  	cursor: move;
}
li.green {
	background-color: #ecf3e1;
  	border: 1px solid #c5dea1;
}
li.orange {
	background-color: #fff4d8;
  	border: 1px solid #e8a400;
}'! !

TestCase subclass: #ITTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

ITTest subclass: #ITTestGlorpDB
	instanceVariableNames: 'login accessor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITTestGlorpDB methodsFor: 'testing' stamp: 'afk 12/13/2007 14:52'!
setUp
	
	super setUp.
	login := ITGlorpDB login.
	accessor := DatabaseAccessor forLogin: login.! !

!ITTestGlorpDB methodsFor: 'testing' stamp: 'mt 12/14/2007 15:47'!
testConnect
	"Tests whether ITGlorpDB>>#connect answers with a valid GlorpSession which could be used for operating with the SQL database."
	
	| session |
	session := ITGlorpDB connect.
	
	self assert: (login username = session currentLogin username) description: 'Username of session does not equal login username'.
	self assert: (login connectString = session currentLogin connectString) description: 'ConnectString of session does not equal login ConnectString'.
	self assert: (login password = session currentLogin password) description: 'Password of session does not equal login password '.
	
	self assert: session isLoggedIn.! !

!ITTestGlorpDB methodsFor: 'testing' stamp: 'mt 12/14/2007 15:44'!
testLogin
	"Tests whether it is possible to use the default login for connecting to a vaild SQL database which is used in the whole application."
	
	self assert: accessor isLoggedIn not.
	accessor loginIfError: [:exception | self assert: false.].
	self assert: accessor isLoggedIn.
	accessor logout.
	self assert: accessor isLoggedIn not.! !

!ITTestGlorpDB methodsFor: 'testing' stamp: 'mig 12/20/2007 18:53'!
testUniqueSession
	"Tests whether a glorp session really is a singleton."


	self assert: ITGlorpSession getInstance notNil description: 'Glorp session is nil.'.
	self assert: (ITGlorpSession getInstance == ITGlorpSession getInstance) description: 'Glorp session is not unique.'.! !

ITTest subclass: #ITTestIssue
	instanceVariableNames: 'issue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITTestIssue methodsFor: 'testing' stamp: 'mt 12/30/2007 11:39'!
setUp

	super setUp.
	issue := ITIssue new.! !

!ITTestIssue methodsFor: 'testing' stamp: 'mt 12/14/2007 16:33'!
testAddComment
	
	issue addComment: 'TESTCOMMENT'.
	
	self 
		assert: issue comments last content = 'TESTCOMMENT' 
		description: 'A just added comment could not be retrieved from the issue.'! !

!ITTestIssue methodsFor: 'testing' stamp: 'mt 12/14/2007 16:32'!
testComments
	"Tests whether the accessors for #comments do what they should do - set and get."
	
	| comments |
	comments := OrderedCollection new.
	issue comments: comments.
	
	self 
		assert: issue comments == comments 
		description: 'An ordered collection of comments was just set and could not be retrieved from the issue.'! !

!ITTestIssue methodsFor: 'testing' stamp: 'mt 12/14/2007 16:32'!
testDetails
	"Tests whether the accessors for #details do what they should do - set and get."
	
	| details |
	details := OrderedCollection new.
	issue details: details.
	
	self 
		assert: issue details == details 
		description: 'An ordered collection of details was just set and could not be retrieved from the issue.'! !

!ITTestIssue methodsFor: 'testing' stamp: 'mt 12/14/2007 16:32'!
testGetTag

	| detail |
	detail := ITIssueDetail new.
	detail tag: 'title'.
	detail content: 'TESTTITLE'.
	issue details: detail asOrderedCollection.
	
	self 
		assert: (issue getTag: 'title') = 'TESTTITLE' 
		description: 'A just added detail could not be retrieved from the issue.'! !

!ITTestIssue methodsFor: 'testing' stamp: 'mt 12/14/2007 16:30'!
testId
	"Tests whether the accessors for #id do what they should do - set and get."

	issue id: 1.
	
	self
		assert: issue id = 1 
		description: 'An id was just set and could not be retrieved from the issue.'! !

!ITTestIssue methodsFor: 'testing' stamp: 'mt 12/14/2007 16:31'!
testSetDetailWithTo
	
	issue setDetailWith: 'title' to: 'TESTTITLE'.
	
	self 
		assert: (issue getTag: 'title') = 'TESTTITLE' 
		description: 'A new detail was set and could not be retrieved from the issue.'! !

ITTest subclass: #ITTestIssueComment
	instanceVariableNames: 'comment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITTestIssueComment methodsFor: 'testing' stamp: 'mt 12/30/2007 11:39'!
setUp

	super setUp.
	comment := ITIssueComment new.! !

!ITTestIssueComment methodsFor: 'testing' stamp: 'mt 12/14/2007 16:29'!
testContent
	"Tests whether the accessors for #content do what they should do - set and get."

	comment content: 'TESTCOMMENT'.
	
	self 
		assert: comment content = 'TESTCOMMENT' 
		description: 'A content was just set and could not be retrieved from the comment.'! !

!ITTestIssueComment methodsFor: 'testing' stamp: 'mt 12/14/2007 16:29'!
testId
	"Tests whether the accessors for #id do what they should do - set and get."

	comment id: 1.
	
	self 
		assert: comment id = 1 
		description: 'An id was just set and could not be retrieved from the comment.'! !

ITTest subclass: #ITTestIssueDetail
	instanceVariableNames: 'detail'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITTestIssueDetail methodsFor: 'testing' stamp: 'mt 12/30/2007 11:39'!
setUp

	super setUp.
	detail := ITIssueDetail new.! !

!ITTestIssueDetail methodsFor: 'testing' stamp: 'mt 12/14/2007 16:28'!
testContent
	"Tests whether the accessors for #content do what they should do - set and get."

	detail content: 'TESTCONTENT'.
	
	self 
		assert: detail content = 'TESTCONTENT' 
		description: 'A content was just set and could not be retrieved from the detail.'! !

!ITTestIssueDetail methodsFor: 'testing' stamp: 'mt 12/14/2007 16:26'!
testId
	"Tests whether the accessors for #id do what they should do - set and get."

	detail id: 1.
	
	self 
		assert: detail id = 1 
		description: 'An id was just set and could not be retrieved from the detail.'! !

!ITTestIssueDetail methodsFor: 'testing' stamp: 'mt 12/14/2007 16:27'!
testTag
	"Tests whether the accessors for #tag do what they should do - set and get."

	detail tag: 'TESTTAG'.
	
	self 
		assert: detail tag = 'TESTTAG' 
		description: 'A tag was just set and could not be retrieved from the detail.'! !

ITTest subclass: #ITTestIssueManager
	instanceVariableNames: 'issueManager'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITTestIssueManager methodsFor: 'testing' stamp: 'mt 12/30/2007 11:39'!
setUp
	
	super setUp.
	issueManager := ITIssueManager new.! !

!ITTestIssueManager methodsFor: 'testing' stamp: 'mt 12/15/2007 10:47'!
testAddCommentAtID

	| issue |
	issue := issueManager addIssueWithTitle: 'tmp_testAddCommentAtID'.
	
	issueManager addComment: 'tmp_testAddCommentAtID_comment' atID: issue id.
	
	self 
		assert: (issueManager getIssueWithID: issue id) comments last content = 'tmp_testAddCommentAtID_comment'
		description: 'A comment to a new issue was just set and could not be retrieved through an issue manager.'.
	
	issueManager deleteIssueWithID: issue id.! !

!ITTestIssueManager methodsFor: 'testing' stamp: 'mt 12/15/2007 10:55'!
testAddIssueWithTitle
	
	| issue |
	issue := issueManager addIssueWithTitle: 'tmp_testAddIssueWithTitle'.
	
	self 
		assert: (issue isKindOf: ITIssue) 
		description: 'ITIssueManager>>#addIssueWithTitle: is not returning an object with type ITIssue'.
		
	self
		deny: (issue id) isNil
		description: 'ITIssueManager>>#addIssueWithTitle: returns an ITIssue object which has no ID.'.
		
	self
		assert: ((issueManager getIssueWithID: issue id) getTag: 'title') = 'tmp_testAddIssueWithTitle'
		description: 'A new issue with a title was just set and the title could not be retrieved through an issue manager.'.
	
	issueManager deleteIssueWithID: issue id.! !

!ITTestIssueManager methodsFor: 'testing' stamp: 'mt 12/15/2007 12:51'!
testAddIssueWithTitleWithComment

	| issue |
	issue := issueManager
		addIssueWithTitle: 'tmp_testAddIssueWithTitleWithComment'
		withComment: 'tmp_testAddIssueWithTitleWithComment_comment'.
	
	self 
		assert: (issue isKindOf: ITIssue) 
		description: 'ITIssueManager>>#addIssueWithTitle:WithComment: is not returning an object with type ITIssue'.
		
	self
		deny: (issue id) isNil
		description: 'ITIssueManager>>#addIssueWithTitle:WithComment: returns an ITIssue object which has no ID.'.
		
	self
		assert: ((issueManager getIssueWithID: issue id) getTag: 'title') = 'tmp_testAddIssueWithTitleWithComment'
		description: 'A new issue with a title and a comment was just set and the title could not be retrieved through an issue manager.'.
		
	self
		assert: ((issueManager getIssueWithID: issue id) comments last content) = 'tmp_testAddIssueWithTitleWithComment_comment'
		description: 'A new issue with a title and a comment was just set and the comment could not be retrieved through an issue manager.'.		
	
	issueManager deleteIssueWithID: issue id.
! !

!ITTestIssueManager methodsFor: 'testing' stamp: 'mt 12/15/2007 10:51'!
testDeleteIssueWithID

	| issue |
	
	issue := issueManager addIssueWithTitle: 'tmp_testDeleteIssueWithID'.
	
	issueManager deleteIssueWithID: issue id.
	
	self
		assert: (issueManager getIssueWithID: issue id) isNil
		description: 'A new issue was just added and could not be deleted through an issue manager.'
	

	! !

!ITTestIssueManager methodsFor: 'testing' stamp: 'mt 12/15/2007 10:54'!
testGetIssueWithID
	
	| issue |
	issue := issueManager addIssueWithTitle: 'tmp_testGetIssueWithID'.
	
	self
		assert: ((issueManager getIssueWithID: issue id) getTag: 'title') = 'tmp_testGetIssueWithID'
		description: 'A new issue was just added and could not be retrieved through an issue manager'.
		
	issueManager deleteIssueWithID: issue id.! !

!ITTestIssueManager methodsFor: 'testing' stamp: 'mt 12/15/2007 11:04'!
testGetIssues
	
	issueManager getIssues do: [ :issue |
		self 
			assert: (issue isKindOf: ITIssue)
			description: 'ITIssueManager>>#getIssues returns a collection in where not all objects are issues.'.
		
		self
			deny: (issue id) isNil
			description: 'ITIssueManager>>#getIssues returns a collection in where not all issues have an ID.'.
	].
	
	
	! !

ITTest subclass: #ITTestRole
	instanceVariableNames: 'role'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITTestRole methodsFor: 'testing' stamp: 'mt 12/30/2007 11:39'!
setUp

	super setUp.
	role := ITRole new! !

!ITTestRole methodsFor: 'testing' stamp: 'mt 12/30/2007 11:20'!
testAddPrivilege
	"Tests whether it is possible to add a privilege but not twice the same one."
	
	2 timesRepeat: [role addPrivilege: 'write'].

	self
		assert: role privileges size = 1
		description: 'A privilege was added twice to a role.'! !

!ITTestRole methodsFor: 'testing' stamp: 'mt 12/30/2007 11:27'!
testHasPrivilege
	"Tests whether it is possible to add a privilege to a role and ask this role whether it has this privilege."
	
	role addPrivilege: 'write'.
		
	self
		assert: (role hasPrivilege: 'write')
		description: 'A privilege was just added and could not be retrieved from a role.'! !

!ITTestRole methodsFor: 'testing' stamp: 'mt 12/30/2007 11:18'!
testId
	"Tests whether the accessors for #id do what they should do - set and get."

	role id: 1.
	
	self
		assert: role id = 1 
		description: 'An id was just set and could not be retrieved from the role.'! !

!ITTestRole methodsFor: 'testing' stamp: 'mt 12/30/2007 11:23'!
testPrivileges
	"Tests whether the accessors for #privileges do what they should do - set and get."

	| somePrivileges |
	somePrivileges := #('read' 'read' 'write' 'write').
	role privileges: somePrivileges.
	
	self
		assert: (role privileges isKindOf: Set) 
		description: 'The privileges of a role are not a set.'.
		
	self
		assert: role privileges = #('read' 'write') asSet
		description: 'Some privileges where just set to a role and could not be retrieved.' ! !

!ITTestRole methodsFor: 'testing' stamp: 'mt 12/30/2007 11:28'!
testRemovePrivilege
	"Tests whether it is possible to remove a privilege from a role."
	
	role
		addPrivilege: 'write';
		removePrivilege: 'write'.

	self
		assert: role privileges size = 0
		description: 'A privilege was added and could not be removed from a role.'! !

!ITTestRole methodsFor: 'testing' stamp: 'mt 12/30/2007 11:15'!
testRolename
	"Tests whether the accessors for #rolename do what they should do - set and get."

	role rolename: 'testrole'.
	
	self
		assert: role rolename = 'testrole'
		description: 'A rolename was just set and could not be retrieved from the role.'! !

ITTest subclass: #ITTestSecurityManager
	instanceVariableNames: 'securityManager'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITTestSecurityManager methodsFor: 'testing' stamp: 'mt 12/30/2007 11:58'!
setUp

	super setUp.
	securityManager := ITSecurityManager new.! !

!ITTestSecurityManager methodsFor: 'testing' stamp: 'mt 12/30/2007 12:48'!
testAddRole
	"Tests whether it is possible to add a new role to the database."
	
	|role|
	role := ITRole new.
	role rolename: 'tmp_testAddRole'.
	
	securityManager addRole: role.
	
	self
		deny: role id isNil 
		description: 'New role could not be added to database through security manager because it got no ID.'.
		
	securityManager deleteRoleWithID: role id.! !

!ITTestSecurityManager methodsFor: 'testing' stamp: 'mt 12/30/2007 13:09'!
testAddUser
	"Tests whether it is possible to add a new user to the database."
	
	|user|
	user := ITUser new.
	user username: 'tmp_testAddUser'.
	
	securityManager addUser: user.
	
	self
		deny: user id isNil 
		description: 'New user could not be added to database through security manager because it got no ID.'.
		
	securityManager deleteUserWithID: user id.! !

!ITTestSecurityManager methodsFor: 'testing' stamp: 'mt 12/30/2007 12:56'!
testDeleteRoleWithID
	"Tests whether it is possible to remove a role with a given ID from the database."
	
	|role|
	role := ITRole new.
	role rolename: 'tmp_testDeleteRoleWithID'.
	securityManager 
		addRole: role;
		deleteRoleWithID: role id.
		
	self
		assert: (securityManager getRoleWithID: role id) isNil
		description: 'A role could not be deleted through a security manager.'
	! !

!ITTestSecurityManager methodsFor: 'testing' stamp: 'mt 12/30/2007 13:10'!
testDeleteUserWithID
	"Tests whether it is possible to remove a user with a given ID from the database."
	
	|user|
	user := ITUser new.
	user username: 'tmp_testDeleteUserWithID'.
	securityManager 
		addUser: user;
		deleteUserWithID: user id.
		
	self
		assert: (securityManager getUserWithID: user id) isNil
		description: 'A user could not be deleted through a security manager.'
	! !

!ITTestSecurityManager methodsFor: 'testing' stamp: 'mt 12/30/2007 13:40'!
testGetRole
	"Tests whether it is possible to retrieve a role instance with a given rolename from the database."
	
	|role|
	role := ITRole new.
	role rolename: 'tmp_testGetRoleWithID'.
	securityManager addRole: role.
	
	self
		assert: ((securityManager getRole: role rolename) isKindOf: ITRole)
		description: 'A new role was just added to the database through a security manager and could not be retrieved by its name.'.
	
	securityManager deleteRoleWithID: role id.! !

!ITTestSecurityManager methodsFor: 'testing' stamp: 'mt 12/30/2007 12:53'!
testGetRoleWithID
	"Tests whether it is possible to retrieve a role instance with a given ID from the database."
	
	|role|
	role := ITRole new.
	role rolename: 'tmp_testGetRoleWithID'.
	securityManager addRole: role.
	
	self
		assert: (securityManager getRoleWithID: role id) rolename = 'tmp_testGetRoleWithID'
		description: 'A new role was just added to the database through a security manager and could not be retrieved.'.
	
	securityManager deleteRoleWithID: role id.! !

!ITTestSecurityManager methodsFor: 'testing' stamp: 'mt 12/30/2007 13:40'!
testGetUser
	"Tests whether it is possible to retrieve a user instance with a given username from the database."
	
	|user|
	user := ITUser new.
	user username: 'tmp_testGetUser'.
	securityManager addUser: user.
	
	self
		assert: ((securityManager getUser: user username) isKindOf: ITUser)
		description: 'A new user was just added to the database through a security manager and could not be retrieved by its name.'.
	
	securityManager deleteUserWithID: user id.! !

!ITTestSecurityManager methodsFor: 'testing' stamp: 'mt 12/30/2007 13:41'!
testGetUserWithID
	"Tests whether it is possible to retrieve a user instance with a given ID from the database."
	
	|user|
	user := ITUser new.
	user username: 'tmp_testGetUserWithID'.
	securityManager addUser: user.
	
	self
		assert: (securityManager getUserWithID: user id) username = 'tmp_testGetUserWithID'
		description: 'A new user was just added to the database through a security manager and could not be retrieved.'.
	
	securityManager deleteUserWithID: user id.! !

ITTest subclass: #ITTestSession
	instanceVariableNames: 'session'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITTestSession methodsFor: 'testing' stamp: 'mt 12/30/2007 11:53'!
setUp

	super setUp.
	session := ITSession new.! !

!ITTestSession methodsFor: 'testing' stamp: 'mt 12/30/2007 11:41'!
testIssueManager
	"Tests whether there is only one issue manager per session."
	
	self
		assert: session issueManager == session issueManager
		description: 'An ITSession instance returns different ITIssueManager instances. There should only be one.'! !

!ITTestSession methodsFor: 'testing' stamp: 'mt 12/30/2007 11:44'!
testLanguage
	"Tests whether it is possible to set and get a language for translation issues."
	
	session language: #english.
	
	self
		assert: session language = #english
		description: 'A language was just set and could not be retrieved from a session.'! !

!ITTestSession methodsFor: 'testing' stamp: 'mt 12/30/2007 11:42'!
testSecurityManager
	"Tests whether there is only one security manager per session."
	
	self
		assert: session securityManager == session securityManager
		description: 'An ITSession instance returns different ITSecurityManager instances. There should only be one.'! !

!ITTestSession methodsFor: 'testing' stamp: 'mt 12/30/2007 11:52'!
testUser
	"Tests whether it is possible to set and get a user for a session."
	
	| user |
	user := ITUser new.
	
	session user: user.
	
	self
		assert: session user == user
		description: 'A user was just set and could not be retrieved from a session.'! !

ITTest subclass: #ITTestTranslator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITTestTranslator methodsFor: 'testing' stamp: 'mt 12/26/2007 12:16'!
testDiscardTranslationsForLanguage
	"Tests whether all translations for a given language will be discarded."

	(ITTranslator getInstance loadTranslationFile: 'example.ts' forLanguage: #example).
	
	self
		assert: (ITTranslator getInstance translate: 'test' into: #example) = 'test'
		description: 'The test string should not be translated but was modified.'! !

!ITTestTranslator methodsFor: 'testing' stamp: 'mt 12/26/2007 12:14'!
testLoadTranslationFileForLanguage
	"Tests whether it is possible to load a translation file (a lookup dictionary or so)."
	
	(ITTranslator getInstance loadTranslationFile: 'example.ts' forLanguage: #example).
	
	self
		assert: (ITTranslator getInstance translate: 'test' into: #example) = 'test_translated'
		description: 'Could not translate test string.'! !

!ITTestTranslator methodsFor: 'testing' stamp: 'mt 12/26/2007 11:09'!
testSingleton
	"Tests whether ITTranslator is a singleton."
	
	self
		assert: ITTranslator getInstance == ITTranslator getInstance
		description: ITTranslator name, '(class)>>#getInstance returns variing objects. Should be a Singleton.'.
		
	[ITTranslator new]
		on: Exception
		do: [^self].
		
	self
		assert: false
		description: ITTranslator name, '(class)>>#new does not throws an Exception!! Should be a Singleton.'! !

!ITTestTranslator methodsFor: 'testing' stamp: 'mt 12/26/2007 12:00'!
testTr
	"Tests whether ByteString>>#tr does return a byte string as well."
	
	self
		assert: ('test' tr isKindOf: ByteString)
		description: 'ByteString>>#tr does not return an instance of ByteString.'! !

!ITTestTranslator methodsFor: 'testing' stamp: 'mt 12/26/2007 12:15'!
testTranslateInto
	"Tests whether the same text is returned if no translation is used."
	
	self
		assert: (ITTranslator getInstance translate: 'No Translation' into: #default) = 'No Translation'
		description: 'Text was modified while no translation was performed!!'! !

ITTest subclass: #ITTestUser
	instanceVariableNames: 'user adminRole guestRole'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITTestUser methodsFor: 'testing' stamp: 'mt 12/30/2007 11:40'!
setUp

	super setUp.
	user := ITUser new.
	
	adminRole := ITRole new.
	adminRole rolename: 'admin'.
	
	guestRole := ITRole new.
	guestRole rolename: 'guest'.! !

!ITTestUser methodsFor: 'testing' stamp: 'mt 12/30/2007 10:59'!
testAddRole
	"Tests whether it is possible to add a role but not twice the same role."
	
	2 timesRepeat: [user addRole: guestRole].

	self
		assert: user roles size = 1
		description: 'A role was added twice to a user.'! !

!ITTestUser methodsFor: 'testing' stamp: 'mt 12/30/2007 10:36'!
testId
	"Tests whether the accessors for #id do what they should do - set and get."

	user id: 1.
	
	self
		assert: user id = 1 
		description: 'An id was just set and could not be retrieved from the user.'! !

!ITTestUser methodsFor: 'testing' stamp: 'mt 12/30/2007 11:00'!
testIsInRole
	"Tests whether it is possible to add a role to a user and ask this user whether he is in that role."
	
	user addRole: adminRole.
		
	self
		assert: (user isInRole: adminRole)
		description: 'A role was just added and could not be retrieved from a user.'! !

!ITTestUser methodsFor: 'testing' stamp: 'mt 12/30/2007 10:41'!
testPassword
	"Tests whether a password for a user can be set and retrieved as hash for security reasons."

	|password hash|
	password :=	'justsomestupidpasswordwhichwillneverbeinplaintextagain'.
	hash := ITSecurityManager hashPassword: password.
	
	user setPassword: password.
	
	self
		assert: user passwordHash = hash
		description: 'The user got another password hash as from ITSecurityManager(class)>>#hashPassword:.'
! !

!ITTestUser methodsFor: 'testing' stamp: 'mt 12/30/2007 11:00'!
testRemoveRole
	"Tests whether it is possible to remove a role."
	
	user
		addRole: adminRole;
		removeRole: adminRole.

	self
		assert: user roles size = 0
		description: 'A role was added and could not be removed from a user'! !

!ITTestUser methodsFor: 'testing' stamp: 'mt 12/30/2007 11:22'!
testRoles
	"Tests whether the accessors for #roles do what they should do - set and get."

	| someRoles |
	someRoles := {adminRole. adminRole. guestRole. guestRole}.
	user roles: someRoles.
	
	self
		assert: (user roles isKindOf: Set) 
		description: 'The roles of an user are not a set.'.
		
	self
		assert: user roles = {adminRole. guestRole} asSet
		description: 'Some roles where just set to a user and could not be retrieved.' ! !

!ITTestUser methodsFor: 'testing' stamp: 'mt 12/30/2007 10:37'!
testUsername
	"Tests whether the accessors for #username do what they should do - set and get."

	user username: 'testuser'.
	
	self
		assert: user username = 'testuser' 
		description: 'A username was just set and could not be retrieved from the user.'! !

Object subclass: #ITGlorpDB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITGlorpDB commentStamp: 'mt 12/14/2007 10:22' prior: 0!
I encapsulate the connection to a SQL database, at the moment with PostGreSQL. Feel free to use my class side method #connect to get a new ITGlorpSession instance. But be aware of the connection. You'll have to check whether ITGlorpSession>>#isLoggedIn.!

!ITGlorpDB class methodsFor: 'debug' stamp: 'mt 12/14/2007 10:37'!
closeAllConnections
	ITGlorpSession allInstances do: [:aSession |
		aSession logout.
		Transcript show: 'DEBUG: You closed a Session.']! !

!ITGlorpDB class methodsFor: 'connection' stamp: 'mt 12/15/2007 12:30'!
connect
	"Connects to the database with the given information from login and returns the current (new) session."	
	
	| accessor session system |
	accessor := DatabaseAccessor forLogin: self login.
	accessor login.

	session := GlorpSession new.
	session accessor: accessor.

	system := ITGlorpDescriptorSystem new.
	session system: system.
	system platform: session platform.
	
	^ session
! !

!ITGlorpDB class methodsFor: 'debug' stamp: 'mig 12/16/2007 16:35'!
createTables
	"I'm creating alle relevant tables but only if there are none of them."
	
	| session |
	Transcript show: 'DEBUG: You try to create all tables again.'.
	session := ITGlorpDB connect.
	session inTransactionDo: [session system allTables do: [:each |
			Transcript cr; show: each name; cr.
			session accessor createTable: each ifError: [:error | Transcript show: error messageText]
		]
	].

	session inTransactionDo: [session system allTables do: [:each |
	session accessor createTableFKConstraints: each ifError: [:error | Transcript show: error messageText]		
		]
	].! !

!ITGlorpDB class methodsFor: 'connection' stamp: 'mt 12/29/2007 14:30'!
login
	"The default login can be found here. It is used across the whole issue tracker application. It is also used for unit tests."
	
	^ Login new database: PostgreSQLPlatform new;
		username: 'issuetracker';
		password: 'weloveseasidedontwe';
		connectString: 'theresnoplacelike.homeftp.org:5432_issuetracker'.
		
	"^ Login new database: PostgreSQLPlatform new;
		username: 'postgres';
		password: '1234';
		connectString: 'localhost:5432_postgres'."! !

Object subclass: #ITIssue
	instanceVariableNames: 'id details comments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITIssue class methodsFor: 'instance creation' stamp: 'afk 12/13/2007 20:12'!
with: aTitle with: aComment

	| newIssue comment |
	newIssue := self new.
	comment := ITIssueComment new.
	
	comment content: aComment.
	
	newIssue comments add: comment.
	newIssue details add: (ITIssueDetail with: 'title' with: aTitle).

	^ newIssue! !

!ITIssue methodsFor: 'changing' stamp: 'mt 12/15/2007 16:20'!
addComment: aString

	self comments add: (ITIssueComment with: aString).! !

!ITIssue methodsFor: 'accessing' stamp: 'mt 11/23/2007 19:55'!
comments
	^comments.! !

!ITIssue methodsFor: 'accessing' stamp: 'mt 12/11/2007 15:23'!
comments: aCollection
	comments := aCollection.! !

!ITIssue methodsFor: 'accessing' stamp: 'afk 12/13/2007 17:03'!
details
	^ details! !

!ITIssue methodsFor: 'accessing' stamp: 'afk 12/13/2007 17:03'!
details: anObject
	details := anObject! !

!ITIssue methodsFor: 'accessing' stamp: 'afk 12/13/2007 18:18'!
getTag: tag
	details do: 
		[:each | 
		each tag = tag
			ifTrue: [^ each content]
		].
	^nil.! !

!ITIssue methodsFor: 'accessing' stamp: 'afk 11/12/2007 16:20'!
id
	^ id! !

!ITIssue methodsFor: 'changing' stamp: 'afk 11/12/2007 16:20'!
id: anObject
	id := anObject! !

!ITIssue methodsFor: 'initialize-release' stamp: 'mt 12/15/2007 16:20'!
initialize

	super initialize.
	details := OrderedCollection new.
	comments := OrderedCollection new.

	! !

!ITIssue methodsFor: 'changing' stamp: 'mt 12/15/2007 16:20'!
setDetailWith: aTag to: aValue
	self details add: (ITIssueDetail with: aTag with: aValue)! !

Object subclass: #ITIssueComment
	instanceVariableNames: 'id content'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITIssueComment class methodsFor: 'instance creation' stamp: 'mig 11/30/2007 18:22'!
newWithID: aNumber WithString: aString
	^ self new
		id: aNumber;
		content: aString;
		yourself.! !

!ITIssueComment class methodsFor: 'instance creation' stamp: 'afk 12/13/2007 20:52'!
with: aComment
	^ self new
		content: aComment;
		yourself.! !

!ITIssueComment methodsFor: 'accessing' stamp: 'mig 11/30/2007 17:18'!
content
	^ content! !

!ITIssueComment methodsFor: 'accessing' stamp: 'mig 11/30/2007 17:18'!
content: anObject
	content := anObject! !

!ITIssueComment methodsFor: 'accessing' stamp: 'mig 11/30/2007 17:18'!
id
	^ id! !

!ITIssueComment methodsFor: 'accessing' stamp: 'mig 11/30/2007 17:18'!
id: anObject
	id := anObject! !

!ITIssueComment methodsFor: 'initialize-release' stamp: 'mt 12/14/2007 10:02'!
initialize
	
	super initialize.
	
	content := ''.! !

Object subclass: #ITIssueDetail
	instanceVariableNames: 'id tag content'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITIssueDetail class methodsFor: 'instance creation' stamp: 'mig 12/20/2007 18:51'!
with: aTag with: aValue
	
	| detail |
	detail := self new.
	detail tag: aTag.
	detail content: aValue.
	
	^ detail.! !

!ITIssueDetail methodsFor: 'accessing' stamp: 'afk 12/13/2007 16:54'!
content
	^ content! !

!ITIssueDetail methodsFor: 'accessing' stamp: 'afk 12/13/2007 16:54'!
content: anObject
	content := anObject! !

!ITIssueDetail methodsFor: 'accessing' stamp: 'afk 12/13/2007 16:52'!
id
	^ id! !

!ITIssueDetail methodsFor: 'accessing' stamp: 'afk 12/13/2007 16:52'!
id: anObject
	id := anObject! !

!ITIssueDetail methodsFor: 'accessing' stamp: 'afk 12/13/2007 16:52'!
tag
	^ tag! !

!ITIssueDetail methodsFor: 'accessing' stamp: 'afk 12/13/2007 16:52'!
tag: anObject
	tag := anObject! !

Object subclass: #ITIssueManager
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITIssueManager methodsFor: 'accessing' stamp: 'mt 12/15/2007 12:34'!
addComment: aString atID: aNumber
	"Adds a new ITIssueComment object with the content 'aString' to the issue with the ID 'aNumber'."

	| issue glorpSession |
	glorpSession := ITGlorpSession getInstance.
	issue := glorpSession readOneOf: ITIssue where: [:each | each id = aNumber].
	
	glorpSession inUnitOfWorkDo: [
		glorpSession register: issue.
		issue addComment: aString.
	].! !

!ITIssueManager methodsFor: 'changing' stamp: 'mt 12/15/2007 12:35'!
addIssueWithTitle: aString
	"Adds a new issue with a detail 'title' to the database. Returns this new issue."
	
	| session issue |
	session := ITGlorpSession getInstance.
	
	issue := ITIssue new.
	issue setDetailWith: 'title' to: aString.
	
	session inUnitOfWorkDo: [
		session register: issue.
	].

	^issue.! !

!ITIssueManager methodsFor: 'changing' stamp: 'mt 12/15/2007 12:50'!
addIssueWithTitle: aTitleString withComment: aCommentString
	"Adds a new issue with a title and an initial comment to the database. Returns this new issue."
	
	| session issue |
	session := ITGlorpSession getInstance.
	issue := ITIssue with: aTitleString with: aCommentString.
	
	session inUnitOfWorkDo: [
		session register: issue.
	].
	
	^issue.! !

!ITIssueManager methodsFor: 'accessing' stamp: 'mt 12/15/2007 12:35'!
deleteIssueWithID: aNumber
	"Tries to delete an issue with the given ID from the database."
	
	| session issue |
	session := ITGlorpSession getInstance.
	
	issue := session readOneOf: ITIssue where: [:each | each id = aNumber].
	
	session delete: issue.
	! !

!ITIssueManager methodsFor: 'accessing' stamp: 'mig 12/23/2007 21:27'!
getIssueWithID: aNumber
	"Returns an ITIssue object where the 'id' equals 'aNumber'."
	| glorpSession |
	
	self flag: #TODO.
	"ITSecurityManager checkPrivilege: #readissue."

	glorpSession := ITGlorpSession getInstance.
	^ glorpSession readOneOf: ITIssue where: [:each | each id = aNumber].
! !

!ITIssueManager methodsFor: 'accessing' stamp: 'mig 12/23/2007 21:27'!
getIssues
	"Returns all ITIssue objects in a collection that are in the database"
	
	self flag: #TODO.
	"ITSecurityManager checkPrivilege: #listissues."

	^ ITGlorpSession getInstance readManyOf: ITIssue.
	! !

Object subclass: #ITRole
	instanceVariableNames: 'id rolename privileges users'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITRole methodsFor: 'accessing' stamp: 'mig 12/17/2007 15:07'!
addPrivilege: aSymbol
	privileges add: aSymbol asString! !

!ITRole methodsFor: 'testing' stamp: 'mt 12/30/2007 11:24'!
hasPrivilege: aSymbol
	^ privileges includes: aSymbol! !

!ITRole methodsFor: 'accessing' stamp: 'mig 12/16/2007 16:23'!
id
	^ id! !

!ITRole methodsFor: 'accessing' stamp: 'mig 12/16/2007 16:23'!
id: anObject
	id := anObject! !

!ITRole methodsFor: 'initialization' stamp: 'mt 12/29/2007 10:28'!
initialize
	super initialize.
	
	privileges := Set new.
	rolename := 'unnamed'.! !

!ITRole methodsFor: 'accessing' stamp: 'mig 12/16/2007 16:49'!
privileges
	^ privileges! !

!ITRole methodsFor: 'accessing' stamp: 'mt 12/30/2007 11:24'!
privileges: somePrivileges
	"Ensure that privileges are a set."
	
	privileges := somePrivileges asSet! !

!ITRole methodsFor: 'accessing' stamp: 'mig 12/17/2007 15:09'!
removePrivilege: aSymbol
	privileges remove: aSymbol asString.! !

!ITRole methodsFor: 'accessing' stamp: 'mig 12/16/2007 15:53'!
rolename
	^ rolename! !

!ITRole methodsFor: 'accessing' stamp: 'mig 12/16/2007 15:53'!
rolename: anObject
	rolename := anObject! !

Object subclass: #ITSecurityManager
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITSecurityManager class methodsFor: 'testing' stamp: 'mig 12/22/2007 17:00'!
checkPrivilege: aSymbol 
	| currentSession |
	
	currentSession := WACurrentSession value.
	
	(currentSession securityManager hasUser: currentSession user privilege: aSymbol) ifFalse: [
		ITUnauthorizedError signal.
	].

	^ true.! !

!ITSecurityManager class methodsFor: 'hashing' stamp: 'mig 12/22/2007 17:13'!
hashAlgorithm
	^MD5! !

!ITSecurityManager class methodsFor: 'hashing' stamp: 'mig 12/22/2007 17:13'!
hashPassword: aString
	^ (self hashAlgorithm hashMessage: aString) hex.
	! !

!ITSecurityManager class methodsFor: 'hashing' stamp: 'mig 12/22/2007 17:15'!
hashSize
	"hash size is algorithms size * 2 because hashs are stored as hex"
	^ self hashAlgorithm hashSize * 2
	! !

!ITSecurityManager methodsFor: 'traits' stamp: 'mig 12/22/2007 17:22'!
addRole: aRole
	"add an ITRole object to the database"
	| session |
	
	session := ITGlorpSession getInstance.
	
	session inUnitOfWorkDo: [
		session register: aRole.
	].! !

!ITSecurityManager methodsFor: 'traits' stamp: 'mig 12/22/2007 17:22'!
addUser: aUser
	"add an ITUser object to the database"
	| session |
	
	session := ITGlorpSession getInstance.
	
	session inUnitOfWorkDo: [
		session register: aUser.
	].! !

!ITSecurityManager methodsFor: 'as yet unclassified' stamp: 'mt 12/30/2007 12:11'!
deleteRoleWithID: aNumber
	"Removes a role with the given ID from the database."
	
	|session role|
	session := ITGlorpSession getInstance.
	
	role := session readOneOf: ITRole where: [:each | each id = aNumber].
	
	session delete: role.! !

!ITSecurityManager methodsFor: 'as yet unclassified' stamp: 'mt 12/30/2007 12:10'!
deleteUserWithID: aNumber
	"Removes a user with the given ID from the database."
	
	|session user|
	session := ITGlorpSession getInstance.
	
	user := session readOneOf: ITUser where: [:each | each id = aNumber].
	
	session delete: user.! !

!ITSecurityManager methodsFor: 'as yet unclassified' stamp: 'mig 12/22/2007 17:22'!
getRole: aString
	"get ITRole object from database"
	| session |
	
	session := ITGlorpSession getInstance.
	^session readOneOf: ITRole where: [:each | each rolename = aString].
	! !

!ITSecurityManager methodsFor: 'as yet unclassified' stamp: 'mt 12/30/2007 12:13'!
getRoleWithID: aNumber
	"get ITRole object with the given ID from database"
	
	| session |
	session := ITGlorpSession getInstance.
	^session readOneOf: ITRole where: [:each | each id = aNumber]
	! !

!ITSecurityManager methodsFor: 'as yet unclassified' stamp: 'mig 12/22/2007 17:21'!
getUser: aString
	"get ITUser object from database"
	| session |
	
	session := ITGlorpSession getInstance.
	^session readOneOf: ITUser where: [:each | each username = aString].
	! !

!ITSecurityManager methodsFor: 'as yet unclassified' stamp: 'mt 12/30/2007 12:12'!
getUserWithID: aNumber
	"get ITUser object with the given ID from database"
	
	| session |
	session := ITGlorpSession getInstance.
	^session readOneOf: ITUser where: [:each | each id = aNumber]
	! !

!ITSecurityManager methodsFor: 'testing' stamp: 'mig 12/23/2007 21:24'!
hasUser: aUser privilege: aSymbol
	"check whether aUser has the aSymbol privilege"
	| user |
	
	user := self userOrDefaultUser: aUser.
	
	user roles do: [:role |
		(role hasPrivilege: aSymbol) ifTrue: [^true].
	].

	^false.! !

!ITSecurityManager methodsFor: 'as yet unclassified' stamp: 'mig 12/22/2007 17:20'!
userOrDefaultUser: aUser
	"return aUser if not nil, return the default user if nil"
	
	^aUser ifNil: [self getUser: '*DEFAULT']! !

!ITSecurityManager methodsFor: 'as yet unclassified' stamp: 'mig 12/22/2007 17:21'!
validatePassword: aPassword for: aUsername
	"return whether aUsername and aPassword match"
	| user pwhash |
	
	user := self getUser: aUsername.
	pwhash := self class hashPassword: aPassword.
	
	user ifNil: [^false].
	^ user passwordHash = pwhash.! !

Object subclass: #ITTranslator
	instanceVariableNames: 'phraseBooks'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

ITTranslator class
	instanceVariableNames: 'instance'!

!ITTranslator commentStamp: 'mt 12/26/2007 10:42' prior: 0!
I am responsible for managing all localization/internationalization issues in this application. You have to load a valid translation file and then any ByteString can be translated using ByteString>>#tr.!

ITTranslator class
	instanceVariableNames: 'instance'!

!ITTranslator class methodsFor: 'accesssing' stamp: 'mt 12/26/2007 10:53'!
getInstance
	"Using singleton pattern to ensure that there is only one instance of ITTranslator"
	
	instance ifNil:
		[ instance := self basicNew.].
	^ instance! !

!ITTranslator class methodsFor: 'instance creation' stamp: 'mt 12/26/2007 10:50'!
new
	Error signal: 'Use getInstance because ', self name, ' is a singleton'.! !

!ITTranslator methodsFor: 'translation' stamp: 'mt 12/26/2007 12:19'!
discardTranslationsForLanguage: aSymbol
	"Discards the given phrase book."
	
	phraseBooks
		removeKey: aSymbol
		ifAbsent: ["No such phrase book found."].! !

!ITTranslator methodsFor: 'initialization' stamp: 'mt 12/26/2007 11:49'!
initialize
	super initialize.
	
	phraseBooks := Dictionary new.! !

!ITTranslator methodsFor: 'translation' stamp: 'mt 12/26/2007 12:12'!
loadTranslationFile: aFilePath forLanguage: aSymbol
	"Creats a new phrase book for lookup."
	
	self flag: #TODO
! !

!ITTranslator methodsFor: 'private' stamp: 'mt 12/26/2007 11:50'!
phraseBookFor: aLanguage
	^phraseBooks at: aLanguage.! !

!ITTranslator methodsFor: 'translation' stamp: 'mt 12/26/2007 12:23'!
translate: aByteString into: aLanguage

	|phraseBook translation|	
	[phraseBook := self phraseBookFor: aLanguage]
		on: Error "key not found"
		do: [translation := aByteString].
	
	[translation := phraseBook at: aByteString]
		on: Error "key not found or invalid phrase book"
		do: [translation := aByteString].
	
	^translation.! !

Object subclass: #ITUser
	instanceVariableNames: 'id username passwordHash roles'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITUser methodsFor: 'accessing' stamp: 'mig 12/17/2007 15:00'!
addRole: aRole
	roles add: aRole.! !

!ITUser methodsFor: 'accessing' stamp: 'mig 12/16/2007 16:26'!
id
	^ id! !

!ITUser methodsFor: 'accessing' stamp: 'mig 12/16/2007 16:26'!
id: anObject
	id := anObject! !

!ITUser methodsFor: 'initialization' stamp: 'mt 12/29/2007 09:49'!
initialize
	super initialize.
	
	roles := Set new.! !

!ITUser methodsFor: 'testing' stamp: 'mt 12/30/2007 11:08'!
isInRole: aRole
	^roles includes: aRole! !

!ITUser methodsFor: 'accessing' stamp: 'mig 12/10/2007 17:27'!
passwordHash
	^ passwordHash! !

!ITUser methodsFor: 'accessing' stamp: 'mig 12/17/2007 15:10'!
removeRole: aRole
	roles remove: aRole.! !

!ITUser methodsFor: 'accessing' stamp: 'mig 12/10/2007 17:27'!
roles
	^ roles! !

!ITUser methodsFor: 'accessing' stamp: 'mt 12/30/2007 11:21'!
roles: someRoles
	"Ensure that roles are a set."

	roles := someRoles asSet! !

!ITUser methodsFor: 'passwords' stamp: 'mig 12/17/2007 13:36'!
setPassword: aString
	passwordHash := ITSecurityManager hashPassword: aString.! !

!ITUser methodsFor: 'accessing' stamp: 'mig 12/10/2007 17:27'!
username
	^ username! !

!ITUser methodsFor: 'accessing' stamp: 'mig 12/10/2007 17:27'!
username: anObject
	username := anObject! !

WASession subclass: #ITSession
	instanceVariableNames: 'issueManager language securityManager user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITSession methodsFor: 'accessing' stamp: 'mig 12/10/2007 17:45'!
issueManager
	issueManager ifNil: [
		issueManager := ITIssueManager new.
	].
	
	^issueManager.! !

!ITSession methodsFor: 'accessing' stamp: 'mt 12/26/2007 11:36'!
language
	^ language! !

!ITSession methodsFor: 'accessing' stamp: 'mt 12/26/2007 11:36'!
language: anObject
	language := anObject! !

!ITSession methodsFor: 'accessing' stamp: 'mig 12/10/2007 17:46'!
securityManager
	securityManager ifNil: [
		securityManager := ITSecurityManager new.
	].
	
	^securityManager.! !

!ITSession methodsFor: 'accessing' stamp: 'mig 12/10/2007 17:46'!
user
	^ user! !

!ITSession methodsFor: 'accessing' stamp: 'mig 12/10/2007 17:46'!
user: anObject
	user := anObject! !

!ByteString methodsFor: '*SWE-IssueTracker' stamp: 'mt 12/26/2007 11:42'!
tr
	"Uses ITTranslator for translating this string into another language."	
		
	|lang|
	[lang := WACurrentSession language]
		on: MessageNotUnderstood "for testing purpose only"
		do: [lang := #default].
		
	^ITTranslator getInstance translate: self into: lang.! !

Error subclass: #ITError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

ITError subclass: #ITUnauthorizedError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITUnauthorizedError commentStamp: 'mig 12/22/2007 16:58' prior: 0!
An ITUnauthorizedError is thrown, when a user has not sufficient privileges to perform an action.!
